#!/bin/bash
# Simple build script, potentially useful if building a GPL-redistributable
# version on a system *without* SPEC CPU2017.  See:
#
#     https://www.spec.org/cpu2017/Docs/licenses.html#GPLtarballs
#
# Note: if the benchmark uses "specpp", that is the freely-redistributable
#       preprocessor "filepp".   It is described at 
#         https://www.spec.org/cpu2017/Docs/utility.html#specpp  
#       and will need to be in your path.  You can find filepp sources as
#       modified by SPEC in redistributable_sources/modified/tools.src/harness-spec.tar.xz 
#---------------------------------------------------------------------------

/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/creator/creator.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/creator/creator.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_playanim.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_playanim.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_cursors.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_cursors.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_dragdrop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_dragdrop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_event_system.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_event_system.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_files.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_files.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_gesture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_gesture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_init_exit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_init_exit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_jobs.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_jobs.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_keymap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_keymap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_operators.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_operators.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_subwindow.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_subwindow.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/windowmanager/intern/wm_window.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/windowmanager/intern/wm_window.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_api/spacetypes.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_api/spacetypes.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_action/action_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_action/action_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_action/action_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_action/action_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_action/action_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_action/action_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_action/action_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_action/action_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_action/space_action.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_action/space_action.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_buttons/buttons_context.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_buttons/buttons_context.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_buttons/buttons_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_buttons/buttons_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_buttons/buttons_texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_buttons/buttons_texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_buttons/space_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_buttons/space_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_console/console_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_console/console_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_console/console_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_console/console_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_console/space_console.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_console/space_console.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/file_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/file_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/file_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/file_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/file_panels.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/file_panels.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/filelist.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/filelist.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/filesel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/filesel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/fsmenu.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/fsmenu.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_file/space_file.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_file/space_file.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/graph_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/graph_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_graph/space_graph.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_graph/space_graph.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_image/image_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_image/image_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_image/image_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_image/image_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_image/image_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_image/image_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_image/image_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_image/image_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_image/space_image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_image/space_image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/info_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/info_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/info_stats.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/info_stats.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/info_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/info_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/info_report.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/info_report.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/textview.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/textview.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_info/space_info.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_info/space_info.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_logic/logic_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_logic/logic_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_logic/logic_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_logic/logic_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_logic/logic_window.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_logic/logic_window.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_logic/space_logic.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_logic/space_logic.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_channels.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_channels.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/nla_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/nla_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_nla/space_nla.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_nla/space_nla.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/drawnode.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/drawnode.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_group.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_group.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_relationships.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_relationships.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_templates.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_templates.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_toolbar.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_toolbar.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/node_view.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/node_view.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_node/space_node.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_node/space_node.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_tools.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_tools.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/outliner_tree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/outliner_tree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_outliner/space_outliner.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_outliner/space_outliner.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_script/script_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_script/script_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_script/script_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_script/script_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_script/space_script.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_script/space_script.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_modifier.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_modifier.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_scopes.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_scopes.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/sequencer_view.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/sequencer_view.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_sequencer/space_sequencer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_sequencer/space_sequencer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/space_text.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/space_text.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_autocomplete.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_autocomplete.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_format.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_format.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_format_lua.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_format_lua.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_format_osl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_format_osl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_format_py.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_format_py.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_header.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_header.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_text/text_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_text/text_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_time/space_time.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_time/space_time.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_time/time_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_time/time_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_userpref/space_userpref.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_userpref/space_userpref.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_userpref/userpref_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_userpref/userpref_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/drawanimviz.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/drawanimviz.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/drawarmature.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/drawarmature.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/drawmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/drawmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/drawobject.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/drawobject.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/drawvolume.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/drawvolume.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/space_view3d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/space_view3d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_camera_control.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_camera_control.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_fly.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_fly.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_walk.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_walk.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_header.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_header.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_iterators.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_iterators.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_project.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_project.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_ruler.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_ruler.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_snap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_snap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_toolbar.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_toolbar.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_view3d/view3d_view.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_view3d/view3d_view.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_dopesheet_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_dopesheet_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_dopesheet_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_dopesheet_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_editor.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_editor.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_graph_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_graph_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_graph_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_graph_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_toolbar.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_toolbar.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/clip_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/clip_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/space_clip.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/space_clip.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/tracking_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/tracking_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/space_clip/tracking_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/space_clip/tracking_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_constraints.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_constraints.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_conversions.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_conversions.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_generics.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_generics.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_input.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_input.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_manipulator.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_manipulator.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_orientations.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_orientations.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/transform/transform_snap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/transform/transform_snap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/util/ed_transverts.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/util/ed_transverts.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/util/ed_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/util/ed_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/util/editmode_undo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/util/editmode_undo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/util/numinput.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/util/numinput.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/util/undo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/util/undo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_parametrizer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_parametrizer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_smart_stitch.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_smart_stitch.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/uvedit/uvedit_unwrap_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/uvedit/uvedit_unwrap_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/curve/curve_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/curve/curve_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/curve/editcurve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/curve/editcurve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/curve/editcurve_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/curve/editcurve_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/curve/editfont.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/curve/editfont.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/curve/lorem.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/curve/lorem.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/drawgpencil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/drawgpencil.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/editaction_gpencil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/editaction_gpencil.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/gpencil_buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/gpencil_buttons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/gpencil_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/gpencil_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/gpencil_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/gpencil_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/gpencil_paint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/gpencil_paint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/gpencil/gpencil_undo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/gpencil/gpencil_undo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_anim.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_anim.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_eyedropper.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_eyedropper.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_handlers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_handlers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_icons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_icons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_layout.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_layout.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_panel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_panel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_regions.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_regions.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_style.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_style.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_templates.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_templates.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/interface_widgets.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/interface_widgets.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/resources.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/resources.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/view2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/view2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/interface/view2d_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/interface/view2d_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editface.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editface.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_bevel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_bevel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_bisect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_bisect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_extrude.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_extrude.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_inset.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_inset.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_intersect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_intersect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_knife.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_knife.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_knife_project.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_knife_project.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_loopcut.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_loopcut.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_path.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_path.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_rip.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_rip.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_rip_edge.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_rip_edge.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_tools.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_tools.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/editmesh_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/editmesh_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/mesh_data.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/mesh_data.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/mesh_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/mesh_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mesh/meshtools.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mesh/meshtools.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/metaball/mball_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/metaball/mball_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/metaball/mball_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/metaball/mball_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_bake.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_bake.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_bake_api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_bake_api.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_constraint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_constraint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_group.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_group.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_hook.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_hook.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_lattice.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_lattice.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_lod.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_lod.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_modifier.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_modifier.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_random.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_random.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_relations.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_relations.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_shapekey.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_shapekey.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_transform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_transform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_warp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_warp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/object/object_vgroup.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/object/object_vgroup.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_naming.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_naming.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_relations.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_relations.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_skinning.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_skinning.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/armature_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/armature_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/editarmature_generate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/editarmature_generate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/editarmature_retarget.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/editarmature_retarget.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/editarmature_sketch.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/editarmature_sketch.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/meshlaplacian.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/meshlaplacian.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_lib.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_lib.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_group.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_group.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_slide.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_slide.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_transform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_transform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/pose_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/pose_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/armature/reeb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/armature/reeb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/dynamicpaint_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/dynamicpaint_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/particle_boids.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/particle_boids.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/particle_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/particle_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/particle_object.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/particle_object.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/physics_fluid.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/physics_fluid.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/physics_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/physics_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/physics_pointcache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/physics_pointcache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/rigidbody_constraint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/rigidbody_constraint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/rigidbody_object.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/rigidbody_object.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/physics/rigidbody_world.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/physics/rigidbody_world.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_internal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_internal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_opengl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_opengl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_preview.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_preview.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_shading.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_shading.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_update.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_update.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/render/render_view.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/render/render_view.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/area.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/area.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/glutil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/glutil.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/screen_context.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/screen_context.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/screen_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/screen_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/screen_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/screen_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/screen/screendump.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/screen/screendump.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_cursor.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_cursor.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_curve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_curve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_hide.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_hide.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_image_2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_image_2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_image_proj.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_image_proj.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_mask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_mask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_stroke.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_stroke.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_undo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_undo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_vertex.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_vertex.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/paint_vertex_proj.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/paint_vertex_proj.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/sculpt.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/sculpt.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/sculpt_undo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/sculpt_undo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sculpt_paint/sculpt_uv.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sculpt_paint/sculpt_uv.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/sound/sound_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/sound/sound_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_channels_defines.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_channels_defines.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_channels_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_channels_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_deps.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_deps.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_filter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_filter.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_ipo_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_ipo_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_markers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_markers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/anim_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/anim_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/drivers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/drivers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/fmodifier_ui.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/fmodifier_ui.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/keyframes_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/keyframes_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/keyframes_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/keyframes_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/keyframes_general.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/keyframes_general.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/keyframing.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/keyframing.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/animation/keyingsets.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/animation/keyingsets.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/release/datafiles/bfont.pfb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/release/datafiles/bfont.pfb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/release/datafiles/bfont.ttf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/release/datafiles/bfont.ttf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/release/datafiles/bmonofont.ttf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/release/datafiles/bmonofont.ttf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/release/datafiles/startup.blend.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/release/datafiles/startup.blend.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_add.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_add.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_edit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_edit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_editaction.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_editaction.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_ops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_relationships.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_relationships.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/mask/mask_shapekey.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/mask/mask_shapekey.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/editors/io/io_ops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/editors/io/io_ops.c
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_empty.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_empty.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_octree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_octree.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_raycounter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_raycounter.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_svbvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_svbvh.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_instance.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_instance.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_qbvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_qbvh.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_rtbuild.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_rtbuild.cpp
/usr/bin/g++                -m64 -c -o blender/source/blender/render/intern/raytrace/rayobject_vbvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/render/intern/raytrace/rayobject_vbvh.cpp
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/bake.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/bake.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/bake_api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/bake_api.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/convertblender.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/convertblender.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/envmap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/envmap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/external_engine.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/external_engine.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/imagetexture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/imagetexture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/initrender.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/initrender.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/multires_bake.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/multires_bake.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/occlusion.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/occlusion.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/pipeline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/pipeline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/pixelblending.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/pixelblending.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/pixelshading.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/pixelshading.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/pointdensity.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/pointdensity.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/rayshade.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/rayshade.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/rendercore.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/rendercore.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/render_result.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/render_result.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/render_texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/render_texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/renderdatabase.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/renderdatabase.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/shadbuf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/shadbuf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/shadeinput.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/shadeinput.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/shadeoutput.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/shadeoutput.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/sss.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/sss.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/strand.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/strand.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/sunsky.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/sunsky.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/texture_ocean.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/texture_ocean.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/volume_precache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/volume_precache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/volumetric.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/volumetric.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/voxeldata.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/voxeldata.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/render/intern/source/zbuf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/render/intern/source/zbuf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/ikplugin/intern/ikplugin_api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/ikplugin/intern/ikplugin_api.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_armature.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_armature.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_array.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_array.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_bevel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_bevel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_boolean.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_boolean.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_build.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_build.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_cast.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_cast.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_cloth.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_cloth.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_collision.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_collision.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_curve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_curve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_decimate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_decimate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_displace.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_displace.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_dynamicpaint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_dynamicpaint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_edgesplit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_edgesplit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_explode.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_explode.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_fluidsim.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_fluidsim.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_fluidsim_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_fluidsim_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_hook.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_hook.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_laplaciandeform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_laplaciandeform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_laplaciansmooth.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_laplaciansmooth.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_lattice.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_lattice.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_mask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_mask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_meshcache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_meshcache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_meshcache_mdd.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_meshcache_mdd.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_meshcache_pc2.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_meshcache_pc2.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_meshcache_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_meshcache_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_meshdeform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_meshdeform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_mirror.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_mirror.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_multires.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_multires.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_none.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_none.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_ocean.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_ocean.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_particleinstance.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_particleinstance.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_particlesystem.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_particlesystem.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_remesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_remesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_screw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_screw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_shapekey.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_shapekey.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_shrinkwrap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_shrinkwrap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_simpledeform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_simpledeform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_skin.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_skin.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_smoke.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_smoke.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_smooth.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_smooth.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_softbody.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_softbody.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_solidify.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_solidify.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_subsurf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_subsurf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_surface.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_surface.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_triangulate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_triangulate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_uvwarp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_uvwarp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_uvproject.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_uvproject.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_warp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_warp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_wave.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_wave.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_weightvg_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_weightvg_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_weightvgedit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_weightvgedit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_weightvgmix.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_weightvgmix.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_weightvgproximity.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_weightvgproximity.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/modifiers/intern/MOD_wireframe.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/modifiers/intern/MOD_wireframe.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_beautify.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_beautify.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_bevel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_bevel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_bisect_plane.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_bisect_plane.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_bridge.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_bridge.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_connect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_connect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_connect_nonplanar.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_connect_nonplanar.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_connect_pair.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_connect_pair.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_create.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_create.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_dissolve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_dissolve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_dupe.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_dupe.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_edgenet.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_edgenet.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_extrude.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_extrude.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_fill_attribute.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_fill_attribute.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_fill_edgeloop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_fill_edgeloop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_fill_grid.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_fill_grid.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_fill_holes.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_fill_holes.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_inset.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_inset.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_join_triangles.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_join_triangles.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_mesh_conv.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_mesh_conv.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_mirror.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_mirror.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_normals.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_normals.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_poke.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_poke.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_primitive.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_primitive.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_removedoubles.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_removedoubles.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_similar.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_similar.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_smooth_laplacian.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_smooth_laplacian.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_split_edges.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_split_edges.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_subdivide.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_subdivide.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_subdivide_edgering.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_subdivide_edgering.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_symmetrize.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_symmetrize.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_triangulate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_triangulate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_unsubdivide.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_unsubdivide.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/operators/bmo_wireframe.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/operators/bmo_wireframe.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_construct.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_construct.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_core.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_core.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_edgeloop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_edgeloop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_delete.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_delete.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_interp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_interp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_iterators.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_iterators.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_log.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_log.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_marking.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_marking.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_mesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_mesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_mesh_conv.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_mesh_conv.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_mods.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_mods.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_opdefines.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_opdefines.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_operators.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_operators.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_polygon.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_polygon.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_queries.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_queries.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_structure.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_structure.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_walkers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_walkers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/intern/bmesh_walkers_impl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/intern/bmesh_walkers_impl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_beautify.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_beautify.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_bevel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_bevel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_bisect_plane.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_bisect_plane.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_decimate_collapse.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_decimate_collapse.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_decimate_dissolve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_decimate_dissolve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_decimate_unsubdivide.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_decimate_unsubdivide.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_edgenet.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_edgenet.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_edgesplit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_edgesplit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_intersect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_intersect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_path.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_path.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_region_match.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_region_match.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_triangulate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_triangulate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/bmesh/tools/bmesh_wireframe.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/bmesh/tools/bmesh_wireframe.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/CCGSubSurf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/CCGSubSurf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/DerivedMesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/DerivedMesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/action.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/action.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/addon.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/addon.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/anim.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/anim.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/anim_sys.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/anim_sys.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/armature.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/armature.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/autoexec.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/autoexec.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/blender.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/blender.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/bmfont.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/bmfont.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/boids.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/boids.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/bpath.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/bpath.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/brush.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/brush.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/bullet.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/bullet.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/bvhutils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/bvhutils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/camera.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/camera.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/cdderivedmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/cdderivedmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/cloth.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/cloth.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/collision.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/collision.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/colortools.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/colortools.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/constraint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/constraint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/context.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/context.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/crazyspace.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/crazyspace.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/curve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/curve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/customdata.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/customdata.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/customdata_file.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/customdata_file.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/deform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/deform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/depsgraph.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/depsgraph.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/displist.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/displist.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/dynamicpaint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/dynamicpaint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/editderivedmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/editderivedmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/editmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/editmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/editmesh_bvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/editmesh_bvh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/effect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/effect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/fcurve.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/fcurve.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/fluidsim.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/fluidsim.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/fmodifier.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/fmodifier.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/font.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/font.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/freestyle.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/freestyle.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/gpencil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/gpencil.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/group.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/group.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/icons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/icons.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/idcode.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/idcode.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/idprop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/idprop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/image_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/image_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/implicit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/implicit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/ipo.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/ipo.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/key.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/key.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/lamp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/lamp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/lattice.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/lattice.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/library.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/library.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/library_query.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/library_query.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/linestyle.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/linestyle.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mask_evaluate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mask_evaluate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mask_rasterize.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mask_rasterize.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/material.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/material.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mball.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mball.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mesh_evaluate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mesh_evaluate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mesh_mapping.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mesh_mapping.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/mesh_validate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/mesh_validate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/modifier.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/modifier.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/modifiers_bmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/modifiers_bmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/movieclip.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/movieclip.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/multires.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/multires.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/nla.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/nla.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/node.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/node.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/object.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/object.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/object_deform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/object_deform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/object_dupli.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/object_dupli.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/ocean.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/ocean.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/packedFile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/packedFile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/paint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/paint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/particle.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/particle.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/particle_system.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/particle_system.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/pbvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/pbvh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/pbvh_bmesh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/pbvh_bmesh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/pointcache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/pointcache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/property.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/property.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/report.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/report.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/rigidbody.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/rigidbody.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/sca.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/sca.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/scene.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/scene.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/screen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/screen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/seqcache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/seqcache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/seqeffects.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/seqeffects.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/seqmodifier.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/seqmodifier.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/sequencer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/sequencer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/shrinkwrap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/shrinkwrap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/sketch.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/sketch.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/smoke.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/smoke.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/softbody.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/softbody.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/sound.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/sound.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/speaker.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/speaker.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/subsurf_ccg.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/subsurf_ccg.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/suggestions.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/suggestions.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/text.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/text.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_detect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_detect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_plane_tracker.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_plane_tracker.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_region_tracker.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_region_tracker.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_solver.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_solver.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_stabilize.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_stabilize.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/tracking_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/tracking_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/treehash.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/treehash.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/unit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/unit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/world.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/world.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenkernel/intern/writeavi.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenkernel/intern/writeavi.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_alphaOver.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_alphaOver.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_bilateralblur.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_bilateralblur.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_blur.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_blur.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_brightness.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_brightness.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_channelMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_channelMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_chromaMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_chromaMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_colorMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_colorMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_colorSpill.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_colorSpill.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_colorbalance.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_colorbalance.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_common.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_common.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_composite.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_composite.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_cornerpin.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_cornerpin.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_crop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_crop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_curves.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_curves.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_despeckle.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_despeckle.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_doubleEdgeMask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_doubleEdgeMask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_defocus.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_defocus.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_diffMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_diffMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_dilate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_dilate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_directionalblur.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_directionalblur.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_displace.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_displace.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_distanceMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_distanceMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_filter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_filter.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_flip.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_flip.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_gamma.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_gamma.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_glare.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_glare.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_hueSatVal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_hueSatVal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_huecorrect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_huecorrect.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_idMask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_idMask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_inpaint.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_inpaint.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_invert.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_invert.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_keyingscreen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_keyingscreen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_keying.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_keying.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_lensdist.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_lensdist.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_levels.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_levels.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_lummaMatte.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_lummaMatte.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_mapUV.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_mapUV.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_mapValue.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_mapValue.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_mapRange.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_mapRange.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_math.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_math.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_mask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_mask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_mixrgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_mixrgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_movieclip.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_movieclip.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_moviedistortion.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_moviedistortion.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_normal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_normal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_normalize.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_normalize.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_outputFile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_outputFile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_planetrackdeform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_planetrackdeform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_premulkey.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_premulkey.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_rgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_rgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_rotate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_rotate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_scale.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_scale.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_sepcombHSVA.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_sepcombHSVA.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_sepcombRGBA.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_sepcombRGBA.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_sepcombYCCA.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_sepcombYCCA.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_sepcombYUVA.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_sepcombYUVA.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_setalpha.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_setalpha.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_splitViewer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_splitViewer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_stabilize2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_stabilize2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_sunbeams.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_sunbeams.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_tonemap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_tonemap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_trackpos.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_trackpos.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_transform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_transform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_translate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_translate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_valToRgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_valToRgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_value.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_value.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_vecBlur.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_vecBlur.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_viewer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_viewer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_zcombine.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_zcombine.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_bokehblur.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_bokehblur.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_bokehimage.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_bokehimage.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_boxmask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_boxmask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_ellipsemask.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_ellipsemask.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_switch.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_switch.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_colorcorrection.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_colorcorrection.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/nodes/node_composite_pixelate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/nodes/node_composite_pixelate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/node_composite_tree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/node_composite_tree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/composite/node_composite_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/composite/node_composite_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_camera.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_camera.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_common.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_common.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_curves.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_curves.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_gamma.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_gamma.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_brightness.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_brightness.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_geom.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_geom.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_hueSatVal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_hueSatVal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_invert.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_invert.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_lamp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_lamp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_mapping.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_mapping.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_material.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_material.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_math.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_math.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_mixRgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_mixRgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_normal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_normal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_output.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_output.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_rgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_rgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_sepcombRGB.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_sepcombRGB.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_sepcombHSV.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_sepcombHSV.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_sepcombXYZ.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_sepcombXYZ.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_squeeze.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_squeeze.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_valToRgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_valToRgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_value.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_value.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_wireframe.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_wireframe.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_wavelength.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_wavelength.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_blackbody.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_blackbody.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_vectMath.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_vectMath.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_vectTransform.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_vectTransform.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_add_shader.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_add_shader.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_ambient_occlusion.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_ambient_occlusion.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_attribute.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_attribute.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_background.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_background.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_anisotropic.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_anisotropic.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_diffuse.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_diffuse.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glass.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glass.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glossy.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glossy.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_toon.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_toon.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_refraction.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_refraction.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_translucent.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_translucent.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_transparent.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_transparent.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_velvet.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_velvet.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_hair.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bsdf_hair.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_bump.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_bump.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_emission.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_emission.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_fresnel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_fresnel.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_geometry.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_geometry.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_holdout.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_holdout.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_layer_weight.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_layer_weight.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_light_falloff.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_light_falloff.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_light_path.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_light_path.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_mix_shader.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_mix_shader.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_normal_map.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_normal_map.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_object_info.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_object_info.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_hair_info.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_hair_info.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_output_lamp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_output_lamp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_output_material.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_output_material.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_output_world.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_output_world.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_output_linestyle.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_output_linestyle.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_particle_info.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_particle_info.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_script.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_script.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_subsurface_scattering.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_subsurface_scattering.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tangent.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tangent.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_brick.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_brick.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_checker.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_checker.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_coord.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_coord.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_environment.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_environment.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_gradient.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_gradient.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_magic.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_magic.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_musgrave.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_musgrave.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_noise.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_noise.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_sky.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_sky.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_voronoi.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_voronoi.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_tex_wave.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_tex_wave.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_volume_scatter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_volume_scatter.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_volume_absorption.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_volume_absorption.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_uvAlongStroke.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_uvAlongStroke.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/nodes/node_shader_uvmap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/nodes/node_shader_uvmap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/node_shader_tree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/node_shader_tree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/shader/node_shader_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/shader/node_shader_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_at.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_at.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_bricks.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_bricks.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_checker.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_checker.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_common.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_common.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_compose.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_compose.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_coord.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_coord.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_curves.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_curves.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_decompose.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_decompose.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_distance.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_distance.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_hueSatVal.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_hueSatVal.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_image.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_image.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_invert.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_invert.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_math.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_math.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_mixRgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_mixRgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_output.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_output.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_proc.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_proc.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_rotate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_rotate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_scale.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_scale.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_texture.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_texture.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_translate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_translate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_valToNor.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_valToNor.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_valToRgb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_valToRgb.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/nodes/node_texture_viewer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/nodes/node_texture_viewer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/node_texture_tree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/node_texture_tree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/texture/node_texture_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/texture/node_texture_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/intern/node_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/intern/node_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/intern/node_exec.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/intern/node_exec.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/intern/node_common.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/intern/node_common.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/nodes/intern/node_socket.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/nodes/intern/node_socket.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/makesrna/intern/rna_access.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/makesrna/intern/rna_access.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_ID_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_ID_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_action_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_action_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_actuator_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_actuator_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_animation_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_animation_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_animviz_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_animviz_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_armature_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_armature_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_boid_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_boid_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_brush_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_brush_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_camera_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_camera_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_cloth_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_cloth_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_color_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_color_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_constraint_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_constraint_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_context_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_context_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_controller_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_controller_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_curve_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_curve_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_dynamicpaint_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_dynamicpaint_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_fcurve_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_fcurve_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_fluidsim_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_fluidsim_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_gpencil_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_gpencil_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_group_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_group_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_image_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_image_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_key_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_key_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_lamp_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_lamp_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_lattice_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_lattice_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_linestyle_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_linestyle_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_main_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_main_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_mask_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_mask_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_material_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_material_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_mesh_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_mesh_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_meta_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_meta_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_modifier_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_modifier_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_movieclip_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_movieclip_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_nla_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_nla_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_nodetree_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_nodetree_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_object_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_object_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_object_force_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_object_force_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_packedfile_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_packedfile_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_particle_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_particle_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_pose_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_pose_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_property_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_property_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_render_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_render_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_rigidbody_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_rigidbody_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_rna_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_rna_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_scene_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_scene_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_screen_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_screen_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_sculpt_paint_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_sculpt_paint_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_sensor_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_sensor_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_sequencer_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_sequencer_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_smoke_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_smoke_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_sound_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_sound_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_space_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_space_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_speaker_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_speaker_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_test_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_test_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_text_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_text_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_texture_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_texture_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_timeline_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_timeline_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_tracking_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_tracking_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_ui_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_ui_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_userdef_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_userdef_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_vfont_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_vfont_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_wm_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_wm_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesrna/intern/rna_world_gen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesrna/intern/rna_world_gen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_buffers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_buffers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_codegen.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_codegen.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_draw.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_draw.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_extensions.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_extensions.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_init_exit.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_init_exit.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_material.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_material.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_simple_shader.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_simple_shader.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/gpu/intern/gpu_select.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/gpu/intern/gpu_select.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_material.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_material.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_frag.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_frag.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_vert.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_vert.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_simple_frag.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_simple_frag.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_simple_vert.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_simple_vert.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_vertex.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_vertex.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_frag.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_frag.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_vert.glsl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_vert.glsl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/readblenentry.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/readblenentry.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/readfile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/readfile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/runtime.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/runtime.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/undofile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/undofile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/versioning_250.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/versioning_250.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/versioning_260.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/versioning_260.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/versioning_270.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/versioning_270.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/versioning_defaults.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/versioning_defaults.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/versioning_legacy.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/versioning_legacy.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenloader/intern/writefile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenloader/intern/writefile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/allocimbuf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/allocimbuf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/anim_movie.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/anim_movie.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/bmp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/bmp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/cache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/cache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/colormanagement.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/colormanagement.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/divers.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/divers.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/filetype.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/filetype.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/filter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/filter.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/imageprocess.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/imageprocess.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/indexer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/indexer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/indexer_dv.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/indexer_dv.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/iris.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/iris.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/jpeg.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/jpeg.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/metadata.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/metadata.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/module.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/module.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/moviecache.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/moviecache.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/png.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/png.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/readimage.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/readimage.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/rectop.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/rectop.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/rotate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/rotate.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/scaling.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/scaling.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/targa.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/targa.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/thumbs.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/thumbs.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/thumbs_blend.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/thumbs_blend.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/imbuf/intern/writeimage.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/imbuf/intern/writeimage.c
/usr/bin/g++                -m64 -c -o blender/source/blender/imbuf/intern/openexr/openexr_stub.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/source/blender/imbuf/intern/openexr/openexr_stub.cpp
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_args.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_args.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_array.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_array.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_dial.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_dial.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_dynstr.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_dynstr.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_ghash.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_ghash.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_heap.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_heap.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_kdopbvh.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_kdopbvh.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_kdtree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_kdtree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_linklist.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_linklist.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_memarena.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_memarena.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/BLI_mempool.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/BLI_mempool.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/DLRB_tree.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/DLRB_tree.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/boxpack2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/boxpack2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/buffer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/buffer.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/callbacks.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/callbacks.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/convexhull2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/convexhull2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/easing.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/easing.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/edgehash.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/edgehash.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/endian_switch.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/endian_switch.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/fileops.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/fileops.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/freetypefont.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/freetypefont.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/graph.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/graph.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/gsqueue.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/gsqueue.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/jitter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/jitter.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/lasso.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/lasso.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/listbase.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/listbase.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_base.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_base.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_base_inline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_base_inline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_color.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_color.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_color_blend_inline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_color_blend_inline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_color_inline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_color_inline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_geom.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_geom.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_geom_inline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_geom_inline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_interp.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_interp.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_matrix.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_matrix.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_rotation.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_rotation.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_vector.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_vector.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/math_vector_inline.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/math_vector_inline.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/md5.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/md5.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/noise.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/noise.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/path_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/path_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/polyfill2d.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/polyfill2d.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/quadric.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/quadric.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/rand.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/rand.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/rct.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/rct.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/scanfill.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/scanfill.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/scanfill_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/scanfill_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/smallhash.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/smallhash.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/sort.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/sort.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/sort_utils.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/sort_utils.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/stack.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/stack.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/storage.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/storage.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/string.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/string.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/string_cursor_utf8.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/string_cursor_utf8.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/string_utf8.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/string_utf8.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/system.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/system.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/task.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/task.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/threads.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/threads.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/time.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/time.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/timecode.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/timecode.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/uvproject.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/uvproject.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/voronoi.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/voronoi.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenlib/intern/voxel.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenlib/intern/voxel.c
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_Buttons.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_Buttons.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_C-api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_C-api.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_CallbackEventConsumer.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_CallbackEventConsumer.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_Context.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_Context.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_ContextNone.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_ContextNone.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_DisplayManager.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_DisplayManager.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_EventManager.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_EventManager.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_ISystem.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_ISystem.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_ISystemPaths.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_ISystemPaths.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_ModifierKeys.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_ModifierKeys.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_Path-api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_Path-api.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_Rect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_Rect.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_System.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_System.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_TimerManager.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_TimerManager.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_Window.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_Window.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/GHOST_WindowManager.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/GHOST_WindowManager.cpp
/usr/bin/g++                -m64 -c -o blender/intern/ghost/intern/SPEC_SystemPathsSelect.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/ghost/intern/SPEC_SystemPathsSelect.cpp
/usr/bin/g++                -m64 -c -o blender/intern/string/intern/STR_String.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/string/intern/STR_String.cpp
/usr/bin/g++                -m64 -c -o blender/intern/memutil/intern/MEM_CacheLimiterC-Api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/memutil/intern/MEM_CacheLimiterC-Api.cpp
/usr/bin/g++                -m64 -c -o blender/intern/memutil/intern/MEM_RefCountedC-Api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/memutil/intern/MEM_RefCountedC-Api.cpp
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/guardedalloc/intern/mallocn.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/guardedalloc/intern/mallocn.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/guardedalloc/intern/mallocn_guarded_impl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/guardedalloc/intern/mallocn_guarded_impl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/guardedalloc/intern/mallocn_lockfree_impl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/guardedalloc/intern/mallocn_lockfree_impl.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/extern/colamd/Source/colamd.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/extern/colamd/Source/colamd.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/extern/colamd/Source/colamd_global.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/extern/colamd/Source/colamd_global.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/makesdna/intern/dna_genfile.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/makesdna/intern/dna_genfile.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender_bin/source/blender/makesdna/intern/dna.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender_bin/source/blender/makesdna/intern/dna.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_dir.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_dir.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_font.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_font.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_glyph.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_glyph.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_lang.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_lang.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_translation.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_translation.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/source/blender/blenfont/intern/blf_util.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/source/blender/blenfont/intern/blf_util.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/mikktspace/mikktspace.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/mikktspace/mikktspace.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/raskter/raskter.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/raskter/raskter.c
/usr/bin/g++                -m64 -c -o blender/intern/opencolorio/ocio_capi.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/opencolorio/ocio_capi.cc
/usr/bin/g++                -m64 -c -o blender/intern/opencolorio/fallback_impl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/intern/opencolorio/fallback_impl.cc
/usr/bin/g++                -m64 -c -o blender/extern/rangetree/range_tree_c_api.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/extern/rangetree/range_tree_c_api.cc
/usr/bin/gcc     -std=c99   -m64 -c -o blender/extern/wcwidth/wcwidth.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/extern/wcwidth/wcwidth.c
/usr/bin/g++                -m64 -c -o blender/extern/libmv/intern/stub.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g    -funsigned-char -DSPEC_LINUX     -DSPEC_LP64  blender/extern/libmv/intern/stub.cc
/usr/bin/gcc     -std=c99   -m64 -c -o blender/intern/glew-mx/intern/glew-mx.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/intern/glew-mx/intern/glew-mx.c
/usr/bin/gcc     -std=c99   -m64 -c -o blender/extern/glew/src/glew.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  blender/extern/glew/src/glew.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_gl.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_gl.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_glcorearb.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_glcorearb.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_glu.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_glu.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_glx.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_glx.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_jpeg.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_jpeg.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_ft.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_ft.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/adler32.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/adler32.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/compress.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/compress.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/crc32.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/crc32.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/deflate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/deflate.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/gzclose.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/gzclose.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/gzlib.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/gzlib.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/gzread.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/gzread.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/gzwrite.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/gzwrite.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/infback.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/infback.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/inflate.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/inflate.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/inftrees.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/inftrees.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/trees.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/trees.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/uncompr.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/uncompr.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/zutil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/zutil.c
/usr/bin/gcc     -std=c99   -m64 -c -o zlib/inffast.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  zlib/inffast.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/png.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/png.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngset.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngset.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngget.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngget.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngrutil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngrutil.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngtrans.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngtrans.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngwutil.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngwutil.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngmem.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngmem.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngpread.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngpread.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngread.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngread.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngerror.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngerror.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngwrite.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngwrite.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngrtran.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngrtran.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngwtran.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngwtran.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngrio.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngrio.c
/usr/bin/gcc     -std=c99   -m64 -c -o libpng/pngwio.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  libpng/pngwio.c
/usr/bin/gcc     -std=c99   -m64 -c -o specrand/specrand.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  specrand/specrand.c
/usr/bin/gcc     -std=c99   -m64 -c -o spec_backtrace.o -DSPEC -DSPEC_CPU -DNDEBUG -Ispecrand -Iblender/extern/binreloc/include -Iblender/extern/colamd/Include -Iblender/extern/glew/include -Iblender/extern/libmv -Iblender/extern/libmv/intern -Iblender/extern/rangetree -Iblender/extern/wcwidth -Iblender/intern -Iblender/intern/atomic -Iblender/intern/audaspace/intern -Iblender/intern/cycles/blender -Iblender/intern/elbeem/extern -Iblender/intern/ghost -Iblender/intern/ghost/intern -Iblender/intern/glew-mx -Iblender/intern/glew-mx/intern -Iblender/intern/guardedalloc -Iblender/intern/guardedalloc/intern -Iblender/intern/iksolver/extern -Iblender/intern/locale -Iblender/intern/memutil -Iblender/intern/mikktspace -Iblender/intern/opencolorio -Iblender/intern/raskter -Iblender/intern/smoke/extern -Iblender/intern/string -Iblender/intern/utfconv -Iblender/source/blender/blenfont -Iblender/source/blender/blenfont/intern -Iblender/source/blender/blenkernel -Iblender/source/blender/blenkernel/intern -Iblender/source/blender/blenlib -Iblender/source/blender/blenlib/intern -Iblender/source/blender/blenloader -Iblender/source/blender/blenloader/intern -Iblender/source/blender/bmesh -Iblender/source/blender/bmesh/intern -Iblender/source/blender/bmesh/tools -Iblender/source/blender/collada -Iblender/source/blender/compositor -Iblender/source/blender/editors/animation -Iblender/source/blender/editors/armature -Iblender/source/blender/editors/curve -Iblender/source/blender/editors/gpencil -Iblender/source/blender/editors/include -Iblender/source/blender/editors/interface -Iblender/source/blender/editors/io -Iblender/source/blender/editors/mask -Iblender/source/blender/editors/mesh -Iblender/source/blender/editors/metaball -Iblender/source/blender/editors/object -Iblender/source/blender/editors/physics -Iblender/source/blender/editors/render -Iblender/source/blender/editors/screen -Iblender/source/blender/editors/sculpt_paint -Iblender/source/blender/editors/sound -Iblender/source/blender/editors/space_action -Iblender/source/blender/editors/space_buttons -Iblender/source/blender/editors/space_clip -Iblender/source/blender/editors/space_console -Iblender/source/blender/editors/space_file -Iblender/source/blender/editors/space_graph -Iblender/source/blender/editors/space_image -Iblender/source/blender/editors/space_info -Iblender/source/blender/editors/space_logic -Iblender/source/blender/editors/space_nla -Iblender/source/blender/editors/space_node -Iblender/source/blender/editors/space_outliner -Iblender/source/blender/editors/space_script -Iblender/source/blender/editors/space_sequencer -Iblender/source/blender/editors/space_text -Iblender/source/blender/editors/space_time -Iblender/source/blender/editors/space_userpref -Iblender/source/blender/editors/space_view3d -Iblender/source/blender/editors/transform -Iblender/source/blender/editors/util -Iblender/source/blender/editors/uvedit -Iblender/source/blender/gpu -Iblender/source/blender/gpu/intern -Iblender/source/blender/ikplugin -Iblender/source/blender/ikplugin/intern -Iblender/source/blender/imbuf -Iblender/source/blender/imbuf/intern -Iblender/source/blender/imbuf/intern/openexr -Iblender/source/blender/makesdna -Iblender/source/blender/makesrna -Iblender/source/blender/makesrna/intern -Iblender/source/blender/modifiers -Iblender/source/blender/modifiers/intern -Iblender/source/blender/nodes -Iblender/source/blender/nodes/composite -Iblender/source/blender/nodes/intern -Iblender/source/blender/nodes/shader -Iblender/source/blender/nodes/texture -Iblender/source/blender/python -Iblender/source/blender/render/extern/include -Iblender/source/blender/render/intern/include -Iblender/source/blender/render/intern/raytrace -Iblender/source/blender/windowmanager -Iblender/source/gameengine/BlenderRoutines -Iblender_bin/source/blender/makesrna/intern -Iinclude -Ilibpng -Izlib -DSPEC_AUTO_SUPPRESS_OPENMP -DSPEC_AUTO_BYTEORDER=0x12345678 -DGLEW_NO_ES -DGLEW_STATIC -DWITH_DNA_GHASH -DWITH_GL_PROFILE_COMPAT -DWITH_HEADLESS -DHAVE_UNSIGNED_CHAR  -g        -funsigned-char -DSPEC_LINUX       -DSPEC_LP64  spec_backtrace.c
/usr/bin/g++                -m64      -g     -funsigned-char -DSPEC_LINUX     blender/source/creator/creator.o blender/source/blender/windowmanager/intern/wm.o blender/source/blender/windowmanager/intern/wm_playanim.o blender/source/blender/windowmanager/intern/wm_cursors.o blender/source/blender/windowmanager/intern/wm_dragdrop.o blender/source/blender/windowmanager/intern/wm_draw.o blender/source/blender/windowmanager/intern/wm_event_system.o blender/source/blender/windowmanager/intern/wm_files.o blender/source/blender/windowmanager/intern/wm_gesture.o blender/source/blender/windowmanager/intern/wm_init_exit.o blender/source/blender/windowmanager/intern/wm_jobs.o blender/source/blender/windowmanager/intern/wm_keymap.o blender/source/blender/windowmanager/intern/wm_operators.o blender/source/blender/windowmanager/intern/wm_subwindow.o blender/source/blender/windowmanager/intern/wm_window.o blender/source/blender/editors/space_api/spacetypes.o blender/source/blender/editors/space_action/action_draw.o blender/source/blender/editors/space_action/action_edit.o blender/source/blender/editors/space_action/action_ops.o blender/source/blender/editors/space_action/action_select.o blender/source/blender/editors/space_action/space_action.o blender/source/blender/editors/space_buttons/buttons_context.o blender/source/blender/editors/space_buttons/buttons_ops.o blender/source/blender/editors/space_buttons/buttons_texture.o blender/source/blender/editors/space_buttons/space_buttons.o blender/source/blender/editors/space_console/console_draw.o blender/source/blender/editors/space_console/console_ops.o blender/source/blender/editors/space_console/space_console.o blender/source/blender/editors/space_file/file_draw.o blender/source/blender/editors/space_file/file_ops.o blender/source/blender/editors/space_file/file_panels.o blender/source/blender/editors/space_file/filelist.o blender/source/blender/editors/space_file/filesel.o blender/source/blender/editors/space_file/fsmenu.o blender/source/blender/editors/space_file/space_file.o blender/source/blender/editors/space_graph/graph_buttons.o blender/source/blender/editors/space_graph/graph_draw.o blender/source/blender/editors/space_graph/graph_edit.o blender/source/blender/editors/space_graph/graph_ops.o blender/source/blender/editors/space_graph/graph_select.o blender/source/blender/editors/space_graph/graph_utils.o blender/source/blender/editors/space_graph/space_graph.o blender/source/blender/editors/space_image/image_buttons.o blender/source/blender/editors/space_image/image_draw.o blender/source/blender/editors/space_image/image_edit.o blender/source/blender/editors/space_image/image_ops.o blender/source/blender/editors/space_image/space_image.o blender/source/blender/editors/space_info/info_ops.o blender/source/blender/editors/space_info/info_stats.o blender/source/blender/editors/space_info/info_draw.o blender/source/blender/editors/space_info/info_report.o blender/source/blender/editors/space_info/textview.o blender/source/blender/editors/space_info/space_info.o blender/source/blender/editors/space_logic/logic_buttons.o blender/source/blender/editors/space_logic/logic_ops.o blender/source/blender/editors/space_logic/logic_window.o blender/source/blender/editors/space_logic/space_logic.o blender/source/blender/editors/space_nla/nla_buttons.o blender/source/blender/editors/space_nla/nla_channels.o blender/source/blender/editors/space_nla/nla_draw.o blender/source/blender/editors/space_nla/nla_edit.o blender/source/blender/editors/space_nla/nla_ops.o blender/source/blender/editors/space_nla/nla_select.o blender/source/blender/editors/space_nla/space_nla.o blender/source/blender/editors/space_node/drawnode.o blender/source/blender/editors/space_node/node_add.o blender/source/blender/editors/space_node/node_buttons.o blender/source/blender/editors/space_node/node_draw.o blender/source/blender/editors/space_node/node_edit.o blender/source/blender/editors/space_node/node_group.o blender/source/blender/editors/space_node/node_ops.o blender/source/blender/editors/space_node/node_relationships.o blender/source/blender/editors/space_node/node_select.o blender/source/blender/editors/space_node/node_templates.o blender/source/blender/editors/space_node/node_toolbar.o blender/source/blender/editors/space_node/node_view.o blender/source/blender/editors/space_node/space_node.o blender/source/blender/editors/space_outliner/outliner_draw.o blender/source/blender/editors/space_outliner/outliner_edit.o blender/source/blender/editors/space_outliner/outliner_ops.o blender/source/blender/editors/space_outliner/outliner_select.o blender/source/blender/editors/space_outliner/outliner_tools.o blender/source/blender/editors/space_outliner/outliner_tree.o blender/source/blender/editors/space_outliner/space_outliner.o blender/source/blender/editors/space_script/script_edit.o blender/source/blender/editors/space_script/script_ops.o blender/source/blender/editors/space_script/space_script.o blender/source/blender/editors/space_sequencer/sequencer_add.o blender/source/blender/editors/space_sequencer/sequencer_buttons.o blender/source/blender/editors/space_sequencer/sequencer_draw.o blender/source/blender/editors/space_sequencer/sequencer_edit.o blender/source/blender/editors/space_sequencer/sequencer_modifier.o blender/source/blender/editors/space_sequencer/sequencer_ops.o blender/source/blender/editors/space_sequencer/sequencer_scopes.o blender/source/blender/editors/space_sequencer/sequencer_select.o blender/source/blender/editors/space_sequencer/sequencer_view.o blender/source/blender/editors/space_sequencer/space_sequencer.o blender/source/blender/editors/space_text/space_text.o blender/source/blender/editors/space_text/text_autocomplete.o blender/source/blender/editors/space_text/text_draw.o blender/source/blender/editors/space_text/text_format.o blender/source/blender/editors/space_text/text_format_lua.o blender/source/blender/editors/space_text/text_format_osl.o blender/source/blender/editors/space_text/text_format_py.o blender/source/blender/editors/space_text/text_header.o blender/source/blender/editors/space_text/text_ops.o blender/source/blender/editors/space_time/space_time.o blender/source/blender/editors/space_time/time_ops.o blender/source/blender/editors/space_userpref/space_userpref.o blender/source/blender/editors/space_userpref/userpref_ops.o blender/source/blender/editors/space_view3d/drawanimviz.o blender/source/blender/editors/space_view3d/drawarmature.o blender/source/blender/editors/space_view3d/drawmesh.o blender/source/blender/editors/space_view3d/drawobject.o blender/source/blender/editors/space_view3d/drawvolume.o blender/source/blender/editors/space_view3d/space_view3d.o blender/source/blender/editors/space_view3d/view3d_buttons.o blender/source/blender/editors/space_view3d/view3d_camera_control.o blender/source/blender/editors/space_view3d/view3d_draw.o blender/source/blender/editors/space_view3d/view3d_edit.o blender/source/blender/editors/space_view3d/view3d_fly.o blender/source/blender/editors/space_view3d/view3d_walk.o blender/source/blender/editors/space_view3d/view3d_header.o blender/source/blender/editors/space_view3d/view3d_iterators.o blender/source/blender/editors/space_view3d/view3d_ops.o blender/source/blender/editors/space_view3d/view3d_project.o blender/source/blender/editors/space_view3d/view3d_ruler.o blender/source/blender/editors/space_view3d/view3d_select.o blender/source/blender/editors/space_view3d/view3d_snap.o blender/source/blender/editors/space_view3d/view3d_toolbar.o blender/source/blender/editors/space_view3d/view3d_view.o blender/source/blender/editors/space_clip/clip_buttons.o blender/source/blender/editors/space_clip/clip_dopesheet_draw.o blender/source/blender/editors/space_clip/clip_dopesheet_ops.o blender/source/blender/editors/space_clip/clip_draw.o blender/source/blender/editors/space_clip/clip_editor.o blender/source/blender/editors/space_clip/clip_graph_draw.o blender/source/blender/editors/space_clip/clip_graph_ops.o blender/source/blender/editors/space_clip/clip_ops.o blender/source/blender/editors/space_clip/clip_toolbar.o blender/source/blender/editors/space_clip/clip_utils.o blender/source/blender/editors/space_clip/space_clip.o blender/source/blender/editors/space_clip/tracking_ops.o blender/source/blender/editors/space_clip/tracking_select.o blender/source/blender/editors/transform/transform.o blender/source/blender/editors/transform/transform_constraints.o blender/source/blender/editors/transform/transform_conversions.o blender/source/blender/editors/transform/transform_generics.o blender/source/blender/editors/transform/transform_input.o blender/source/blender/editors/transform/transform_manipulator.o blender/source/blender/editors/transform/transform_ops.o blender/source/blender/editors/transform/transform_orientations.o blender/source/blender/editors/transform/transform_snap.o blender/source/blender/editors/util/ed_transverts.o blender/source/blender/editors/util/ed_util.o blender/source/blender/editors/util/editmode_undo.o blender/source/blender/editors/util/numinput.o blender/source/blender/editors/util/undo.o blender/source/blender/editors/uvedit/uvedit_buttons.o blender/source/blender/editors/uvedit/uvedit_draw.o blender/source/blender/editors/uvedit/uvedit_ops.o blender/source/blender/editors/uvedit/uvedit_parametrizer.o blender/source/blender/editors/uvedit/uvedit_smart_stitch.o blender/source/blender/editors/uvedit/uvedit_unwrap_ops.o blender/source/blender/editors/curve/curve_ops.o blender/source/blender/editors/curve/editcurve.o blender/source/blender/editors/curve/editcurve_add.o blender/source/blender/editors/curve/editfont.o blender/source/blender/editors/curve/lorem.o blender/source/blender/editors/gpencil/drawgpencil.o blender/source/blender/editors/gpencil/editaction_gpencil.o blender/source/blender/editors/gpencil/gpencil_buttons.o blender/source/blender/editors/gpencil/gpencil_edit.o blender/source/blender/editors/gpencil/gpencil_ops.o blender/source/blender/editors/gpencil/gpencil_paint.o blender/source/blender/editors/gpencil/gpencil_undo.o blender/source/blender/editors/interface/interface.o blender/source/blender/editors/interface/interface_anim.o blender/source/blender/editors/interface/interface_draw.o blender/source/blender/editors/interface/interface_eyedropper.o blender/source/blender/editors/interface/interface_handlers.o blender/source/blender/editors/interface/interface_icons.o blender/source/blender/editors/interface/interface_layout.o blender/source/blender/editors/interface/interface_ops.o blender/source/blender/editors/interface/interface_panel.o blender/source/blender/editors/interface/interface_regions.o blender/source/blender/editors/interface/interface_style.o blender/source/blender/editors/interface/interface_templates.o blender/source/blender/editors/interface/interface_utils.o blender/source/blender/editors/interface/interface_widgets.o blender/source/blender/editors/interface/resources.o blender/source/blender/editors/interface/view2d.o blender/source/blender/editors/interface/view2d_ops.o blender/source/blender/editors/mesh/editface.o blender/source/blender/editors/mesh/editmesh_add.o blender/source/blender/editors/mesh/editmesh_bevel.o blender/source/blender/editors/mesh/editmesh_bisect.o blender/source/blender/editors/mesh/editmesh_extrude.o blender/source/blender/editors/mesh/editmesh_inset.o blender/source/blender/editors/mesh/editmesh_intersect.o blender/source/blender/editors/mesh/editmesh_knife.o blender/source/blender/editors/mesh/editmesh_knife_project.o blender/source/blender/editors/mesh/editmesh_loopcut.o blender/source/blender/editors/mesh/editmesh_path.o blender/source/blender/editors/mesh/editmesh_rip.o blender/source/blender/editors/mesh/editmesh_rip_edge.o blender/source/blender/editors/mesh/editmesh_select.o blender/source/blender/editors/mesh/editmesh_tools.o blender/source/blender/editors/mesh/editmesh_utils.o blender/source/blender/editors/mesh/mesh_data.o blender/source/blender/editors/mesh/mesh_ops.o blender/source/blender/editors/mesh/meshtools.o blender/source/blender/editors/metaball/mball_edit.o blender/source/blender/editors/metaball/mball_ops.o blender/source/blender/editors/object/object_add.o blender/source/blender/editors/object/object_bake.o blender/source/blender/editors/object/object_bake_api.o blender/source/blender/editors/object/object_constraint.o blender/source/blender/editors/object/object_edit.o blender/source/blender/editors/object/object_group.o blender/source/blender/editors/object/object_hook.o blender/source/blender/editors/object/object_lattice.o blender/source/blender/editors/object/object_lod.o blender/source/blender/editors/object/object_modifier.o blender/source/blender/editors/object/object_ops.o blender/source/blender/editors/object/object_random.o blender/source/blender/editors/object/object_relations.o blender/source/blender/editors/object/object_select.o blender/source/blender/editors/object/object_shapekey.o blender/source/blender/editors/object/object_transform.o blender/source/blender/editors/object/object_warp.o blender/source/blender/editors/object/object_vgroup.o blender/source/blender/editors/armature/armature_add.o blender/source/blender/editors/armature/armature_edit.o blender/source/blender/editors/armature/armature_naming.o blender/source/blender/editors/armature/armature_ops.o blender/source/blender/editors/armature/armature_relations.o blender/source/blender/editors/armature/armature_select.o blender/source/blender/editors/armature/armature_skinning.o blender/source/blender/editors/armature/armature_utils.o blender/source/blender/editors/armature/editarmature_generate.o blender/source/blender/editors/armature/editarmature_retarget.o blender/source/blender/editors/armature/editarmature_sketch.o blender/source/blender/editors/armature/meshlaplacian.o blender/source/blender/editors/armature/pose_edit.o blender/source/blender/editors/armature/pose_lib.o blender/source/blender/editors/armature/pose_group.o blender/source/blender/editors/armature/pose_select.o blender/source/blender/editors/armature/pose_slide.o blender/source/blender/editors/armature/pose_transform.o blender/source/blender/editors/armature/pose_utils.o blender/source/blender/editors/armature/reeb.o blender/source/blender/editors/physics/dynamicpaint_ops.o blender/source/blender/editors/physics/particle_boids.o blender/source/blender/editors/physics/particle_edit.o blender/source/blender/editors/physics/particle_object.o blender/source/blender/editors/physics/physics_fluid.o blender/source/blender/editors/physics/physics_ops.o blender/source/blender/editors/physics/physics_pointcache.o blender/source/blender/editors/physics/rigidbody_constraint.o blender/source/blender/editors/physics/rigidbody_object.o blender/source/blender/editors/physics/rigidbody_world.o blender/source/blender/editors/render/render_internal.o blender/source/blender/editors/render/render_opengl.o blender/source/blender/editors/render/render_ops.o blender/source/blender/editors/render/render_preview.o blender/source/blender/editors/render/render_shading.o blender/source/blender/editors/render/render_update.o blender/source/blender/editors/render/render_view.o blender/source/blender/editors/screen/area.o blender/source/blender/editors/screen/glutil.o blender/source/blender/editors/screen/screen_context.o blender/source/blender/editors/screen/screen_edit.o blender/source/blender/editors/screen/screen_ops.o blender/source/blender/editors/screen/screendump.o blender/source/blender/editors/sculpt_paint/paint_cursor.o blender/source/blender/editors/sculpt_paint/paint_curve.o blender/source/blender/editors/sculpt_paint/paint_hide.o blender/source/blender/editors/sculpt_paint/paint_image.o blender/source/blender/editors/sculpt_paint/paint_image_2d.o blender/source/blender/editors/sculpt_paint/paint_image_proj.o blender/source/blender/editors/sculpt_paint/paint_mask.o blender/source/blender/editors/sculpt_paint/paint_ops.o blender/source/blender/editors/sculpt_paint/paint_stroke.o blender/source/blender/editors/sculpt_paint/paint_undo.o blender/source/blender/editors/sculpt_paint/paint_utils.o blender/source/blender/editors/sculpt_paint/paint_vertex.o blender/source/blender/editors/sculpt_paint/paint_vertex_proj.o blender/source/blender/editors/sculpt_paint/sculpt.o blender/source/blender/editors/sculpt_paint/sculpt_undo.o blender/source/blender/editors/sculpt_paint/sculpt_uv.o blender/source/blender/editors/sound/sound_ops.o blender/source/blender/editors/animation/anim_channels_defines.o blender/source/blender/editors/animation/anim_channels_edit.o blender/source/blender/editors/animation/anim_deps.o blender/source/blender/editors/animation/anim_draw.o blender/source/blender/editors/animation/anim_filter.o blender/source/blender/editors/animation/anim_ipo_utils.o blender/source/blender/editors/animation/anim_markers.o blender/source/blender/editors/animation/anim_ops.o blender/source/blender/editors/animation/drivers.o blender/source/blender/editors/animation/fmodifier_ui.o blender/source/blender/editors/animation/keyframes_draw.o blender/source/blender/editors/animation/keyframes_edit.o blender/source/blender/editors/animation/keyframes_general.o blender/source/blender/editors/animation/keyframing.o blender/source/blender/editors/animation/keyingsets.o blender_bin/release/datafiles/bfont.pfb.o blender_bin/release/datafiles/bfont.ttf.o blender_bin/release/datafiles/bmonofont.ttf.o blender_bin/release/datafiles/startup.blend.o blender/source/blender/editors/mask/mask_add.o blender/source/blender/editors/mask/mask_draw.o blender/source/blender/editors/mask/mask_edit.o blender/source/blender/editors/mask/mask_editaction.o blender/source/blender/editors/mask/mask_ops.o blender/source/blender/editors/mask/mask_relationships.o blender/source/blender/editors/mask/mask_select.o blender/source/blender/editors/mask/mask_shapekey.o blender/source/blender/editors/io/io_ops.o blender/source/blender/render/intern/raytrace/rayobject.o blender/source/blender/render/intern/raytrace/rayobject_empty.o blender/source/blender/render/intern/raytrace/rayobject_octree.o blender/source/blender/render/intern/raytrace/rayobject_raycounter.o blender/source/blender/render/intern/raytrace/rayobject_svbvh.o blender/source/blender/render/intern/raytrace/rayobject_instance.o blender/source/blender/render/intern/raytrace/rayobject_qbvh.o blender/source/blender/render/intern/raytrace/rayobject_rtbuild.o blender/source/blender/render/intern/raytrace/rayobject_vbvh.o blender/source/blender/render/intern/source/bake.o blender/source/blender/render/intern/source/bake_api.o blender/source/blender/render/intern/source/convertblender.o blender/source/blender/render/intern/source/envmap.o blender/source/blender/render/intern/source/external_engine.o blender/source/blender/render/intern/source/imagetexture.o blender/source/blender/render/intern/source/initrender.o blender/source/blender/render/intern/source/multires_bake.o blender/source/blender/render/intern/source/occlusion.o blender/source/blender/render/intern/source/pipeline.o blender/source/blender/render/intern/source/pixelblending.o blender/source/blender/render/intern/source/pixelshading.o blender/source/blender/render/intern/source/pointdensity.o blender/source/blender/render/intern/source/rayshade.o blender/source/blender/render/intern/source/rendercore.o blender/source/blender/render/intern/source/render_result.o blender/source/blender/render/intern/source/render_texture.o blender/source/blender/render/intern/source/renderdatabase.o blender/source/blender/render/intern/source/shadbuf.o blender/source/blender/render/intern/source/shadeinput.o blender/source/blender/render/intern/source/shadeoutput.o blender/source/blender/render/intern/source/sss.o blender/source/blender/render/intern/source/strand.o blender/source/blender/render/intern/source/sunsky.o blender/source/blender/render/intern/source/texture_ocean.o blender/source/blender/render/intern/source/volume_precache.o blender/source/blender/render/intern/source/volumetric.o blender/source/blender/render/intern/source/voxeldata.o blender/source/blender/render/intern/source/zbuf.o blender/source/blender/ikplugin/intern/ikplugin_api.o blender/source/blender/modifiers/intern/MOD_armature.o blender/source/blender/modifiers/intern/MOD_array.o blender/source/blender/modifiers/intern/MOD_bevel.o blender/source/blender/modifiers/intern/MOD_boolean.o blender/source/blender/modifiers/intern/MOD_build.o blender/source/blender/modifiers/intern/MOD_cast.o blender/source/blender/modifiers/intern/MOD_cloth.o blender/source/blender/modifiers/intern/MOD_collision.o blender/source/blender/modifiers/intern/MOD_curve.o blender/source/blender/modifiers/intern/MOD_decimate.o blender/source/blender/modifiers/intern/MOD_displace.o blender/source/blender/modifiers/intern/MOD_dynamicpaint.o blender/source/blender/modifiers/intern/MOD_edgesplit.o blender/source/blender/modifiers/intern/MOD_explode.o blender/source/blender/modifiers/intern/MOD_fluidsim.o blender/source/blender/modifiers/intern/MOD_fluidsim_util.o blender/source/blender/modifiers/intern/MOD_hook.o blender/source/blender/modifiers/intern/MOD_laplaciandeform.o blender/source/blender/modifiers/intern/MOD_laplaciansmooth.o blender/source/blender/modifiers/intern/MOD_lattice.o blender/source/blender/modifiers/intern/MOD_mask.o blender/source/blender/modifiers/intern/MOD_meshcache.o blender/source/blender/modifiers/intern/MOD_meshcache_mdd.o blender/source/blender/modifiers/intern/MOD_meshcache_pc2.o blender/source/blender/modifiers/intern/MOD_meshcache_util.o blender/source/blender/modifiers/intern/MOD_meshdeform.o blender/source/blender/modifiers/intern/MOD_mirror.o blender/source/blender/modifiers/intern/MOD_multires.o blender/source/blender/modifiers/intern/MOD_none.o blender/source/blender/modifiers/intern/MOD_ocean.o blender/source/blender/modifiers/intern/MOD_particleinstance.o blender/source/blender/modifiers/intern/MOD_particlesystem.o blender/source/blender/modifiers/intern/MOD_remesh.o blender/source/blender/modifiers/intern/MOD_screw.o blender/source/blender/modifiers/intern/MOD_shapekey.o blender/source/blender/modifiers/intern/MOD_shrinkwrap.o blender/source/blender/modifiers/intern/MOD_simpledeform.o blender/source/blender/modifiers/intern/MOD_skin.o blender/source/blender/modifiers/intern/MOD_smoke.o blender/source/blender/modifiers/intern/MOD_smooth.o blender/source/blender/modifiers/intern/MOD_softbody.o blender/source/blender/modifiers/intern/MOD_solidify.o blender/source/blender/modifiers/intern/MOD_subsurf.o blender/source/blender/modifiers/intern/MOD_surface.o blender/source/blender/modifiers/intern/MOD_triangulate.o blender/source/blender/modifiers/intern/MOD_util.o blender/source/blender/modifiers/intern/MOD_uvwarp.o blender/source/blender/modifiers/intern/MOD_uvproject.o blender/source/blender/modifiers/intern/MOD_warp.o blender/source/blender/modifiers/intern/MOD_wave.o blender/source/blender/modifiers/intern/MOD_weightvg_util.o blender/source/blender/modifiers/intern/MOD_weightvgedit.o blender/source/blender/modifiers/intern/MOD_weightvgmix.o blender/source/blender/modifiers/intern/MOD_weightvgproximity.o blender/source/blender/modifiers/intern/MOD_wireframe.o blender/source/blender/bmesh/operators/bmo_beautify.o blender/source/blender/bmesh/operators/bmo_bevel.o blender/source/blender/bmesh/operators/bmo_bisect_plane.o blender/source/blender/bmesh/operators/bmo_bridge.o blender/source/blender/bmesh/operators/bmo_connect.o blender/source/blender/bmesh/operators/bmo_connect_nonplanar.o blender/source/blender/bmesh/operators/bmo_connect_pair.o blender/source/blender/bmesh/operators/bmo_create.o blender/source/blender/bmesh/operators/bmo_dissolve.o blender/source/blender/bmesh/operators/bmo_dupe.o blender/source/blender/bmesh/operators/bmo_edgenet.o blender/source/blender/bmesh/operators/bmo_extrude.o blender/source/blender/bmesh/operators/bmo_fill_attribute.o blender/source/blender/bmesh/operators/bmo_fill_edgeloop.o blender/source/blender/bmesh/operators/bmo_fill_grid.o blender/source/blender/bmesh/operators/bmo_fill_holes.o blender/source/blender/bmesh/operators/bmo_inset.o blender/source/blender/bmesh/operators/bmo_join_triangles.o blender/source/blender/bmesh/operators/bmo_mesh_conv.o blender/source/blender/bmesh/operators/bmo_mirror.o blender/source/blender/bmesh/operators/bmo_normals.o blender/source/blender/bmesh/operators/bmo_poke.o blender/source/blender/bmesh/operators/bmo_primitive.o blender/source/blender/bmesh/operators/bmo_removedoubles.o blender/source/blender/bmesh/operators/bmo_similar.o blender/source/blender/bmesh/operators/bmo_smooth_laplacian.o blender/source/blender/bmesh/operators/bmo_split_edges.o blender/source/blender/bmesh/operators/bmo_subdivide.o blender/source/blender/bmesh/operators/bmo_subdivide_edgering.o blender/source/blender/bmesh/operators/bmo_symmetrize.o blender/source/blender/bmesh/operators/bmo_triangulate.o blender/source/blender/bmesh/operators/bmo_unsubdivide.o blender/source/blender/bmesh/operators/bmo_utils.o blender/source/blender/bmesh/operators/bmo_wireframe.o blender/source/blender/bmesh/intern/bmesh_construct.o blender/source/blender/bmesh/intern/bmesh_core.o blender/source/blender/bmesh/intern/bmesh_edgeloop.o blender/source/blender/bmesh/intern/bmesh_delete.o blender/source/blender/bmesh/intern/bmesh_interp.o blender/source/blender/bmesh/intern/bmesh_iterators.o blender/source/blender/bmesh/intern/bmesh_log.o blender/source/blender/bmesh/intern/bmesh_marking.o blender/source/blender/bmesh/intern/bmesh_mesh.o blender/source/blender/bmesh/intern/bmesh_mesh_conv.o blender/source/blender/bmesh/intern/bmesh_mods.o blender/source/blender/bmesh/intern/bmesh_opdefines.o blender/source/blender/bmesh/intern/bmesh_operators.o blender/source/blender/bmesh/intern/bmesh_polygon.o blender/source/blender/bmesh/intern/bmesh_queries.o blender/source/blender/bmesh/intern/bmesh_structure.o blender/source/blender/bmesh/intern/bmesh_walkers.o blender/source/blender/bmesh/intern/bmesh_walkers_impl.o blender/source/blender/bmesh/tools/bmesh_beautify.o blender/source/blender/bmesh/tools/bmesh_bevel.o blender/source/blender/bmesh/tools/bmesh_bisect_plane.o blender/source/blender/bmesh/tools/bmesh_decimate_collapse.o blender/source/blender/bmesh/tools/bmesh_decimate_dissolve.o blender/source/blender/bmesh/tools/bmesh_decimate_unsubdivide.o blender/source/blender/bmesh/tools/bmesh_edgenet.o blender/source/blender/bmesh/tools/bmesh_edgesplit.o blender/source/blender/bmesh/tools/bmesh_intersect.o blender/source/blender/bmesh/tools/bmesh_path.o blender/source/blender/bmesh/tools/bmesh_region_match.o blender/source/blender/bmesh/tools/bmesh_triangulate.o blender/source/blender/bmesh/tools/bmesh_wireframe.o blender/source/blender/blenkernel/intern/CCGSubSurf.o blender/source/blender/blenkernel/intern/DerivedMesh.o blender/source/blender/blenkernel/intern/action.o blender/source/blender/blenkernel/intern/addon.o blender/source/blender/blenkernel/intern/anim.o blender/source/blender/blenkernel/intern/anim_sys.o blender/source/blender/blenkernel/intern/armature.o blender/source/blender/blenkernel/intern/autoexec.o blender/source/blender/blenkernel/intern/blender.o blender/source/blender/blenkernel/intern/bmfont.o blender/source/blender/blenkernel/intern/boids.o blender/source/blender/blenkernel/intern/bpath.o blender/source/blender/blenkernel/intern/brush.o blender/source/blender/blenkernel/intern/bullet.o blender/source/blender/blenkernel/intern/bvhutils.o blender/source/blender/blenkernel/intern/camera.o blender/source/blender/blenkernel/intern/cdderivedmesh.o blender/source/blender/blenkernel/intern/cloth.o blender/source/blender/blenkernel/intern/collision.o blender/source/blender/blenkernel/intern/colortools.o blender/source/blender/blenkernel/intern/constraint.o blender/source/blender/blenkernel/intern/context.o blender/source/blender/blenkernel/intern/crazyspace.o blender/source/blender/blenkernel/intern/curve.o blender/source/blender/blenkernel/intern/customdata.o blender/source/blender/blenkernel/intern/customdata_file.o blender/source/blender/blenkernel/intern/deform.o blender/source/blender/blenkernel/intern/depsgraph.o blender/source/blender/blenkernel/intern/displist.o blender/source/blender/blenkernel/intern/dynamicpaint.o blender/source/blender/blenkernel/intern/editderivedmesh.o blender/source/blender/blenkernel/intern/editmesh.o blender/source/blender/blenkernel/intern/editmesh_bvh.o blender/source/blender/blenkernel/intern/effect.o blender/source/blender/blenkernel/intern/fcurve.o blender/source/blender/blenkernel/intern/fluidsim.o blender/source/blender/blenkernel/intern/fmodifier.o blender/source/blender/blenkernel/intern/font.o blender/source/blender/blenkernel/intern/freestyle.o blender/source/blender/blenkernel/intern/gpencil.o blender/source/blender/blenkernel/intern/group.o blender/source/blender/blenkernel/intern/icons.o blender/source/blender/blenkernel/intern/idcode.o blender/source/blender/blenkernel/intern/idprop.o blender/source/blender/blenkernel/intern/image.o blender/source/blender/blenkernel/intern/image_gen.o blender/source/blender/blenkernel/intern/implicit.o blender/source/blender/blenkernel/intern/ipo.o blender/source/blender/blenkernel/intern/key.o blender/source/blender/blenkernel/intern/lamp.o blender/source/blender/blenkernel/intern/lattice.o blender/source/blender/blenkernel/intern/library.o blender/source/blender/blenkernel/intern/library_query.o blender/source/blender/blenkernel/intern/linestyle.o blender/source/blender/blenkernel/intern/mask.o blender/source/blender/blenkernel/intern/mask_evaluate.o blender/source/blender/blenkernel/intern/mask_rasterize.o blender/source/blender/blenkernel/intern/material.o blender/source/blender/blenkernel/intern/mball.o blender/source/blender/blenkernel/intern/mesh.o blender/source/blender/blenkernel/intern/mesh_evaluate.o blender/source/blender/blenkernel/intern/mesh_mapping.o blender/source/blender/blenkernel/intern/mesh_validate.o blender/source/blender/blenkernel/intern/modifier.o blender/source/blender/blenkernel/intern/modifiers_bmesh.o blender/source/blender/blenkernel/intern/movieclip.o blender/source/blender/blenkernel/intern/multires.o blender/source/blender/blenkernel/intern/nla.o blender/source/blender/blenkernel/intern/node.o blender/source/blender/blenkernel/intern/object.o blender/source/blender/blenkernel/intern/object_deform.o blender/source/blender/blenkernel/intern/object_dupli.o blender/source/blender/blenkernel/intern/ocean.o blender/source/blender/blenkernel/intern/packedFile.o blender/source/blender/blenkernel/intern/paint.o blender/source/blender/blenkernel/intern/particle.o blender/source/blender/blenkernel/intern/particle_system.o blender/source/blender/blenkernel/intern/pbvh.o blender/source/blender/blenkernel/intern/pbvh_bmesh.o blender/source/blender/blenkernel/intern/pointcache.o blender/source/blender/blenkernel/intern/property.o blender/source/blender/blenkernel/intern/report.o blender/source/blender/blenkernel/intern/rigidbody.o blender/source/blender/blenkernel/intern/sca.o blender/source/blender/blenkernel/intern/scene.o blender/source/blender/blenkernel/intern/screen.o blender/source/blender/blenkernel/intern/seqcache.o blender/source/blender/blenkernel/intern/seqeffects.o blender/source/blender/blenkernel/intern/seqmodifier.o blender/source/blender/blenkernel/intern/sequencer.o blender/source/blender/blenkernel/intern/shrinkwrap.o blender/source/blender/blenkernel/intern/sketch.o blender/source/blender/blenkernel/intern/smoke.o blender/source/blender/blenkernel/intern/softbody.o blender/source/blender/blenkernel/intern/sound.o blender/source/blender/blenkernel/intern/speaker.o blender/source/blender/blenkernel/intern/subsurf_ccg.o blender/source/blender/blenkernel/intern/suggestions.o blender/source/blender/blenkernel/intern/text.o blender/source/blender/blenkernel/intern/texture.o blender/source/blender/blenkernel/intern/tracking.o blender/source/blender/blenkernel/intern/tracking_detect.o blender/source/blender/blenkernel/intern/tracking_plane_tracker.o blender/source/blender/blenkernel/intern/tracking_region_tracker.o blender/source/blender/blenkernel/intern/tracking_solver.o blender/source/blender/blenkernel/intern/tracking_stabilize.o blender/source/blender/blenkernel/intern/tracking_util.o blender/source/blender/blenkernel/intern/treehash.o blender/source/blender/blenkernel/intern/unit.o blender/source/blender/blenkernel/intern/world.o blender/source/blender/blenkernel/intern/writeavi.o blender/source/blender/nodes/composite/nodes/node_composite_alphaOver.o blender/source/blender/nodes/composite/nodes/node_composite_bilateralblur.o blender/source/blender/nodes/composite/nodes/node_composite_blur.o blender/source/blender/nodes/composite/nodes/node_composite_brightness.o blender/source/blender/nodes/composite/nodes/node_composite_channelMatte.o blender/source/blender/nodes/composite/nodes/node_composite_chromaMatte.o blender/source/blender/nodes/composite/nodes/node_composite_colorMatte.o blender/source/blender/nodes/composite/nodes/node_composite_colorSpill.o blender/source/blender/nodes/composite/nodes/node_composite_colorbalance.o blender/source/blender/nodes/composite/nodes/node_composite_common.o blender/source/blender/nodes/composite/nodes/node_composite_composite.o blender/source/blender/nodes/composite/nodes/node_composite_cornerpin.o blender/source/blender/nodes/composite/nodes/node_composite_crop.o blender/source/blender/nodes/composite/nodes/node_composite_curves.o blender/source/blender/nodes/composite/nodes/node_composite_despeckle.o blender/source/blender/nodes/composite/nodes/node_composite_doubleEdgeMask.o blender/source/blender/nodes/composite/nodes/node_composite_defocus.o blender/source/blender/nodes/composite/nodes/node_composite_diffMatte.o blender/source/blender/nodes/composite/nodes/node_composite_dilate.o blender/source/blender/nodes/composite/nodes/node_composite_directionalblur.o blender/source/blender/nodes/composite/nodes/node_composite_displace.o blender/source/blender/nodes/composite/nodes/node_composite_distanceMatte.o blender/source/blender/nodes/composite/nodes/node_composite_filter.o blender/source/blender/nodes/composite/nodes/node_composite_flip.o blender/source/blender/nodes/composite/nodes/node_composite_gamma.o blender/source/blender/nodes/composite/nodes/node_composite_glare.o blender/source/blender/nodes/composite/nodes/node_composite_hueSatVal.o blender/source/blender/nodes/composite/nodes/node_composite_huecorrect.o blender/source/blender/nodes/composite/nodes/node_composite_idMask.o blender/source/blender/nodes/composite/nodes/node_composite_image.o blender/source/blender/nodes/composite/nodes/node_composite_inpaint.o blender/source/blender/nodes/composite/nodes/node_composite_invert.o blender/source/blender/nodes/composite/nodes/node_composite_keyingscreen.o blender/source/blender/nodes/composite/nodes/node_composite_keying.o blender/source/blender/nodes/composite/nodes/node_composite_lensdist.o blender/source/blender/nodes/composite/nodes/node_composite_levels.o blender/source/blender/nodes/composite/nodes/node_composite_lummaMatte.o blender/source/blender/nodes/composite/nodes/node_composite_mapUV.o blender/source/blender/nodes/composite/nodes/node_composite_mapValue.o blender/source/blender/nodes/composite/nodes/node_composite_mapRange.o blender/source/blender/nodes/composite/nodes/node_composite_math.o blender/source/blender/nodes/composite/nodes/node_composite_mask.o blender/source/blender/nodes/composite/nodes/node_composite_mixrgb.o blender/source/blender/nodes/composite/nodes/node_composite_movieclip.o blender/source/blender/nodes/composite/nodes/node_composite_moviedistortion.o blender/source/blender/nodes/composite/nodes/node_composite_normal.o blender/source/blender/nodes/composite/nodes/node_composite_normalize.o blender/source/blender/nodes/composite/nodes/node_composite_outputFile.o blender/source/blender/nodes/composite/nodes/node_composite_planetrackdeform.o blender/source/blender/nodes/composite/nodes/node_composite_premulkey.o blender/source/blender/nodes/composite/nodes/node_composite_rgb.o blender/source/blender/nodes/composite/nodes/node_composite_rotate.o blender/source/blender/nodes/composite/nodes/node_composite_scale.o blender/source/blender/nodes/composite/nodes/node_composite_sepcombHSVA.o blender/source/blender/nodes/composite/nodes/node_composite_sepcombRGBA.o blender/source/blender/nodes/composite/nodes/node_composite_sepcombYCCA.o blender/source/blender/nodes/composite/nodes/node_composite_sepcombYUVA.o blender/source/blender/nodes/composite/nodes/node_composite_setalpha.o blender/source/blender/nodes/composite/nodes/node_composite_splitViewer.o blender/source/blender/nodes/composite/nodes/node_composite_stabilize2d.o blender/source/blender/nodes/composite/nodes/node_composite_sunbeams.o blender/source/blender/nodes/composite/nodes/node_composite_texture.o blender/source/blender/nodes/composite/nodes/node_composite_tonemap.o blender/source/blender/nodes/composite/nodes/node_composite_trackpos.o blender/source/blender/nodes/composite/nodes/node_composite_transform.o blender/source/blender/nodes/composite/nodes/node_composite_translate.o blender/source/blender/nodes/composite/nodes/node_composite_valToRgb.o blender/source/blender/nodes/composite/nodes/node_composite_value.o blender/source/blender/nodes/composite/nodes/node_composite_vecBlur.o blender/source/blender/nodes/composite/nodes/node_composite_viewer.o blender/source/blender/nodes/composite/nodes/node_composite_zcombine.o blender/source/blender/nodes/composite/nodes/node_composite_bokehblur.o blender/source/blender/nodes/composite/nodes/node_composite_bokehimage.o blender/source/blender/nodes/composite/nodes/node_composite_boxmask.o blender/source/blender/nodes/composite/nodes/node_composite_ellipsemask.o blender/source/blender/nodes/composite/nodes/node_composite_switch.o blender/source/blender/nodes/composite/nodes/node_composite_colorcorrection.o blender/source/blender/nodes/composite/nodes/node_composite_pixelate.o blender/source/blender/nodes/composite/node_composite_tree.o blender/source/blender/nodes/composite/node_composite_util.o blender/source/blender/nodes/shader/nodes/node_shader_camera.o blender/source/blender/nodes/shader/nodes/node_shader_common.o blender/source/blender/nodes/shader/nodes/node_shader_curves.o blender/source/blender/nodes/shader/nodes/node_shader_gamma.o blender/source/blender/nodes/shader/nodes/node_shader_brightness.o blender/source/blender/nodes/shader/nodes/node_shader_geom.o blender/source/blender/nodes/shader/nodes/node_shader_hueSatVal.o blender/source/blender/nodes/shader/nodes/node_shader_invert.o blender/source/blender/nodes/shader/nodes/node_shader_lamp.o blender/source/blender/nodes/shader/nodes/node_shader_mapping.o blender/source/blender/nodes/shader/nodes/node_shader_material.o blender/source/blender/nodes/shader/nodes/node_shader_math.o blender/source/blender/nodes/shader/nodes/node_shader_mixRgb.o blender/source/blender/nodes/shader/nodes/node_shader_normal.o blender/source/blender/nodes/shader/nodes/node_shader_output.o blender/source/blender/nodes/shader/nodes/node_shader_rgb.o blender/source/blender/nodes/shader/nodes/node_shader_sepcombRGB.o blender/source/blender/nodes/shader/nodes/node_shader_sepcombHSV.o blender/source/blender/nodes/shader/nodes/node_shader_sepcombXYZ.o blender/source/blender/nodes/shader/nodes/node_shader_squeeze.o blender/source/blender/nodes/shader/nodes/node_shader_texture.o blender/source/blender/nodes/shader/nodes/node_shader_valToRgb.o blender/source/blender/nodes/shader/nodes/node_shader_value.o blender/source/blender/nodes/shader/nodes/node_shader_wireframe.o blender/source/blender/nodes/shader/nodes/node_shader_wavelength.o blender/source/blender/nodes/shader/nodes/node_shader_blackbody.o blender/source/blender/nodes/shader/nodes/node_shader_vectMath.o blender/source/blender/nodes/shader/nodes/node_shader_vectTransform.o blender/source/blender/nodes/shader/nodes/node_shader_add_shader.o blender/source/blender/nodes/shader/nodes/node_shader_ambient_occlusion.o blender/source/blender/nodes/shader/nodes/node_shader_attribute.o blender/source/blender/nodes/shader/nodes/node_shader_background.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_anisotropic.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_diffuse.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glass.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_glossy.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_toon.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_refraction.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_translucent.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_transparent.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_velvet.o blender/source/blender/nodes/shader/nodes/node_shader_bsdf_hair.o blender/source/blender/nodes/shader/nodes/node_shader_bump.o blender/source/blender/nodes/shader/nodes/node_shader_emission.o blender/source/blender/nodes/shader/nodes/node_shader_fresnel.o blender/source/blender/nodes/shader/nodes/node_shader_geometry.o blender/source/blender/nodes/shader/nodes/node_shader_holdout.o blender/source/blender/nodes/shader/nodes/node_shader_layer_weight.o blender/source/blender/nodes/shader/nodes/node_shader_light_falloff.o blender/source/blender/nodes/shader/nodes/node_shader_light_path.o blender/source/blender/nodes/shader/nodes/node_shader_mix_shader.o blender/source/blender/nodes/shader/nodes/node_shader_normal_map.o blender/source/blender/nodes/shader/nodes/node_shader_object_info.o blender/source/blender/nodes/shader/nodes/node_shader_hair_info.o blender/source/blender/nodes/shader/nodes/node_shader_output_lamp.o blender/source/blender/nodes/shader/nodes/node_shader_output_material.o blender/source/blender/nodes/shader/nodes/node_shader_output_world.o blender/source/blender/nodes/shader/nodes/node_shader_output_linestyle.o blender/source/blender/nodes/shader/nodes/node_shader_particle_info.o blender/source/blender/nodes/shader/nodes/node_shader_script.o blender/source/blender/nodes/shader/nodes/node_shader_subsurface_scattering.o blender/source/blender/nodes/shader/nodes/node_shader_tangent.o blender/source/blender/nodes/shader/nodes/node_shader_tex_brick.o blender/source/blender/nodes/shader/nodes/node_shader_tex_checker.o blender/source/blender/nodes/shader/nodes/node_shader_tex_coord.o blender/source/blender/nodes/shader/nodes/node_shader_tex_environment.o blender/source/blender/nodes/shader/nodes/node_shader_tex_gradient.o blender/source/blender/nodes/shader/nodes/node_shader_tex_image.o blender/source/blender/nodes/shader/nodes/node_shader_tex_magic.o blender/source/blender/nodes/shader/nodes/node_shader_tex_musgrave.o blender/source/blender/nodes/shader/nodes/node_shader_tex_noise.o blender/source/blender/nodes/shader/nodes/node_shader_tex_sky.o blender/source/blender/nodes/shader/nodes/node_shader_tex_voronoi.o blender/source/blender/nodes/shader/nodes/node_shader_tex_wave.o blender/source/blender/nodes/shader/nodes/node_shader_volume_scatter.o blender/source/blender/nodes/shader/nodes/node_shader_volume_absorption.o blender/source/blender/nodes/shader/nodes/node_shader_uvAlongStroke.o blender/source/blender/nodes/shader/nodes/node_shader_uvmap.o blender/source/blender/nodes/shader/node_shader_tree.o blender/source/blender/nodes/shader/node_shader_util.o blender/source/blender/nodes/texture/nodes/node_texture_at.o blender/source/blender/nodes/texture/nodes/node_texture_bricks.o blender/source/blender/nodes/texture/nodes/node_texture_checker.o blender/source/blender/nodes/texture/nodes/node_texture_common.o blender/source/blender/nodes/texture/nodes/node_texture_compose.o blender/source/blender/nodes/texture/nodes/node_texture_coord.o blender/source/blender/nodes/texture/nodes/node_texture_curves.o blender/source/blender/nodes/texture/nodes/node_texture_decompose.o blender/source/blender/nodes/texture/nodes/node_texture_distance.o blender/source/blender/nodes/texture/nodes/node_texture_hueSatVal.o blender/source/blender/nodes/texture/nodes/node_texture_image.o blender/source/blender/nodes/texture/nodes/node_texture_invert.o blender/source/blender/nodes/texture/nodes/node_texture_math.o blender/source/blender/nodes/texture/nodes/node_texture_mixRgb.o blender/source/blender/nodes/texture/nodes/node_texture_output.o blender/source/blender/nodes/texture/nodes/node_texture_proc.o blender/source/blender/nodes/texture/nodes/node_texture_rotate.o blender/source/blender/nodes/texture/nodes/node_texture_scale.o blender/source/blender/nodes/texture/nodes/node_texture_texture.o blender/source/blender/nodes/texture/nodes/node_texture_translate.o blender/source/blender/nodes/texture/nodes/node_texture_valToNor.o blender/source/blender/nodes/texture/nodes/node_texture_valToRgb.o blender/source/blender/nodes/texture/nodes/node_texture_viewer.o blender/source/blender/nodes/texture/node_texture_tree.o blender/source/blender/nodes/texture/node_texture_util.o blender/source/blender/nodes/intern/node_util.o blender/source/blender/nodes/intern/node_exec.o blender/source/blender/nodes/intern/node_common.o blender/source/blender/nodes/intern/node_socket.o blender/source/blender/makesrna/intern/rna_access.o blender_bin/source/blender/makesrna/intern/rna_ID_gen.o blender_bin/source/blender/makesrna/intern/rna_action_gen.o blender_bin/source/blender/makesrna/intern/rna_actuator_gen.o blender_bin/source/blender/makesrna/intern/rna_animation_gen.o blender_bin/source/blender/makesrna/intern/rna_animviz_gen.o blender_bin/source/blender/makesrna/intern/rna_armature_gen.o blender_bin/source/blender/makesrna/intern/rna_boid_gen.o blender_bin/source/blender/makesrna/intern/rna_brush_gen.o blender_bin/source/blender/makesrna/intern/rna_camera_gen.o blender_bin/source/blender/makesrna/intern/rna_cloth_gen.o blender_bin/source/blender/makesrna/intern/rna_color_gen.o blender_bin/source/blender/makesrna/intern/rna_constraint_gen.o blender_bin/source/blender/makesrna/intern/rna_context_gen.o blender_bin/source/blender/makesrna/intern/rna_controller_gen.o blender_bin/source/blender/makesrna/intern/rna_curve_gen.o blender_bin/source/blender/makesrna/intern/rna_dynamicpaint_gen.o blender_bin/source/blender/makesrna/intern/rna_fcurve_gen.o blender_bin/source/blender/makesrna/intern/rna_fluidsim_gen.o blender_bin/source/blender/makesrna/intern/rna_gpencil_gen.o blender_bin/source/blender/makesrna/intern/rna_group_gen.o blender_bin/source/blender/makesrna/intern/rna_image_gen.o blender_bin/source/blender/makesrna/intern/rna_key_gen.o blender_bin/source/blender/makesrna/intern/rna_lamp_gen.o blender_bin/source/blender/makesrna/intern/rna_lattice_gen.o blender_bin/source/blender/makesrna/intern/rna_linestyle_gen.o blender_bin/source/blender/makesrna/intern/rna_main_gen.o blender_bin/source/blender/makesrna/intern/rna_mask_gen.o blender_bin/source/blender/makesrna/intern/rna_material_gen.o blender_bin/source/blender/makesrna/intern/rna_mesh_gen.o blender_bin/source/blender/makesrna/intern/rna_meta_gen.o blender_bin/source/blender/makesrna/intern/rna_modifier_gen.o blender_bin/source/blender/makesrna/intern/rna_movieclip_gen.o blender_bin/source/blender/makesrna/intern/rna_nla_gen.o blender_bin/source/blender/makesrna/intern/rna_nodetree_gen.o blender_bin/source/blender/makesrna/intern/rna_object_gen.o blender_bin/source/blender/makesrna/intern/rna_object_force_gen.o blender_bin/source/blender/makesrna/intern/rna_packedfile_gen.o blender_bin/source/blender/makesrna/intern/rna_particle_gen.o blender_bin/source/blender/makesrna/intern/rna_pose_gen.o blender_bin/source/blender/makesrna/intern/rna_property_gen.o blender_bin/source/blender/makesrna/intern/rna_render_gen.o blender_bin/source/blender/makesrna/intern/rna_rigidbody_gen.o blender_bin/source/blender/makesrna/intern/rna_rna_gen.o blender_bin/source/blender/makesrna/intern/rna_scene_gen.o blender_bin/source/blender/makesrna/intern/rna_screen_gen.o blender_bin/source/blender/makesrna/intern/rna_sculpt_paint_gen.o blender_bin/source/blender/makesrna/intern/rna_sensor_gen.o blender_bin/source/blender/makesrna/intern/rna_sequencer_gen.o blender_bin/source/blender/makesrna/intern/rna_smoke_gen.o blender_bin/source/blender/makesrna/intern/rna_sound_gen.o blender_bin/source/blender/makesrna/intern/rna_space_gen.o blender_bin/source/blender/makesrna/intern/rna_speaker_gen.o blender_bin/source/blender/makesrna/intern/rna_test_gen.o blender_bin/source/blender/makesrna/intern/rna_text_gen.o blender_bin/source/blender/makesrna/intern/rna_texture_gen.o blender_bin/source/blender/makesrna/intern/rna_timeline_gen.o blender_bin/source/blender/makesrna/intern/rna_tracking_gen.o blender_bin/source/blender/makesrna/intern/rna_ui_gen.o blender_bin/source/blender/makesrna/intern/rna_userdef_gen.o blender_bin/source/blender/makesrna/intern/rna_vfont_gen.o blender_bin/source/blender/makesrna/intern/rna_wm_gen.o blender_bin/source/blender/makesrna/intern/rna_world_gen.o blender/source/blender/gpu/intern/gpu_buffers.o blender/source/blender/gpu/intern/gpu_codegen.o blender/source/blender/gpu/intern/gpu_draw.o blender/source/blender/gpu/intern/gpu_extensions.o blender/source/blender/gpu/intern/gpu_init_exit.o blender/source/blender/gpu/intern/gpu_material.o blender/source/blender/gpu/intern/gpu_simple_shader.o blender/source/blender/gpu/intern/gpu_select.o blender_bin/source/blender/gpu/shaders/gpu_shader_material.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_frag.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_sep_gaussian_blur_vert.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_simple_frag.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_simple_vert.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_vertex.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_frag.glsl.o blender_bin/source/blender/gpu/shaders/gpu_shader_vsm_store_vert.glsl.o blender/source/blender/blenloader/intern/readblenentry.o blender/source/blender/blenloader/intern/readfile.o blender/source/blender/blenloader/intern/runtime.o blender/source/blender/blenloader/intern/undofile.o blender/source/blender/blenloader/intern/versioning_250.o blender/source/blender/blenloader/intern/versioning_260.o blender/source/blender/blenloader/intern/versioning_270.o blender/source/blender/blenloader/intern/versioning_defaults.o blender/source/blender/blenloader/intern/versioning_legacy.o blender/source/blender/blenloader/intern/writefile.o blender/source/blender/imbuf/intern/allocimbuf.o blender/source/blender/imbuf/intern/anim_movie.o blender/source/blender/imbuf/intern/bmp.o blender/source/blender/imbuf/intern/cache.o blender/source/blender/imbuf/intern/colormanagement.o blender/source/blender/imbuf/intern/divers.o blender/source/blender/imbuf/intern/filetype.o blender/source/blender/imbuf/intern/filter.o blender/source/blender/imbuf/intern/imageprocess.o blender/source/blender/imbuf/intern/indexer.o blender/source/blender/imbuf/intern/indexer_dv.o blender/source/blender/imbuf/intern/iris.o blender/source/blender/imbuf/intern/jpeg.o blender/source/blender/imbuf/intern/metadata.o blender/source/blender/imbuf/intern/module.o blender/source/blender/imbuf/intern/moviecache.o blender/source/blender/imbuf/intern/png.o blender/source/blender/imbuf/intern/readimage.o blender/source/blender/imbuf/intern/rectop.o blender/source/blender/imbuf/intern/rotate.o blender/source/blender/imbuf/intern/scaling.o blender/source/blender/imbuf/intern/targa.o blender/source/blender/imbuf/intern/thumbs.o blender/source/blender/imbuf/intern/thumbs_blend.o blender/source/blender/imbuf/intern/util.o blender/source/blender/imbuf/intern/writeimage.o blender/source/blender/imbuf/intern/openexr/openexr_stub.o blender/source/blender/blenlib/intern/BLI_args.o blender/source/blender/blenlib/intern/BLI_array.o blender/source/blender/blenlib/intern/BLI_dial.o blender/source/blender/blenlib/intern/BLI_dynstr.o blender/source/blender/blenlib/intern/BLI_ghash.o blender/source/blender/blenlib/intern/BLI_heap.o blender/source/blender/blenlib/intern/BLI_kdopbvh.o blender/source/blender/blenlib/intern/BLI_kdtree.o blender/source/blender/blenlib/intern/BLI_linklist.o blender/source/blender/blenlib/intern/BLI_memarena.o blender/source/blender/blenlib/intern/BLI_mempool.o blender/source/blender/blenlib/intern/DLRB_tree.o blender/source/blender/blenlib/intern/boxpack2d.o blender/source/blender/blenlib/intern/buffer.o blender/source/blender/blenlib/intern/callbacks.o blender/source/blender/blenlib/intern/convexhull2d.o blender/source/blender/blenlib/intern/easing.o blender/source/blender/blenlib/intern/edgehash.o blender/source/blender/blenlib/intern/endian_switch.o blender/source/blender/blenlib/intern/fileops.o blender/source/blender/blenlib/intern/freetypefont.o blender/source/blender/blenlib/intern/graph.o blender/source/blender/blenlib/intern/gsqueue.o blender/source/blender/blenlib/intern/jitter.o blender/source/blender/blenlib/intern/lasso.o blender/source/blender/blenlib/intern/listbase.o blender/source/blender/blenlib/intern/math_base.o blender/source/blender/blenlib/intern/math_base_inline.o blender/source/blender/blenlib/intern/math_color.o blender/source/blender/blenlib/intern/math_color_blend_inline.o blender/source/blender/blenlib/intern/math_color_inline.o blender/source/blender/blenlib/intern/math_geom.o blender/source/blender/blenlib/intern/math_geom_inline.o blender/source/blender/blenlib/intern/math_interp.o blender/source/blender/blenlib/intern/math_matrix.o blender/source/blender/blenlib/intern/math_rotation.o blender/source/blender/blenlib/intern/math_vector.o blender/source/blender/blenlib/intern/math_vector_inline.o blender/source/blender/blenlib/intern/md5.o blender/source/blender/blenlib/intern/noise.o blender/source/blender/blenlib/intern/path_util.o blender/source/blender/blenlib/intern/polyfill2d.o blender/source/blender/blenlib/intern/quadric.o blender/source/blender/blenlib/intern/rand.o blender/source/blender/blenlib/intern/rct.o blender/source/blender/blenlib/intern/scanfill.o blender/source/blender/blenlib/intern/scanfill_utils.o blender/source/blender/blenlib/intern/smallhash.o blender/source/blender/blenlib/intern/sort.o blender/source/blender/blenlib/intern/sort_utils.o blender/source/blender/blenlib/intern/stack.o blender/source/blender/blenlib/intern/storage.o blender/source/blender/blenlib/intern/string.o blender/source/blender/blenlib/intern/string_cursor_utf8.o blender/source/blender/blenlib/intern/string_utf8.o blender/source/blender/blenlib/intern/system.o blender/source/blender/blenlib/intern/task.o blender/source/blender/blenlib/intern/threads.o blender/source/blender/blenlib/intern/time.o blender/source/blender/blenlib/intern/timecode.o blender/source/blender/blenlib/intern/uvproject.o blender/source/blender/blenlib/intern/voronoi.o blender/source/blender/blenlib/intern/voxel.o blender/intern/ghost/intern/GHOST_Buttons.o blender/intern/ghost/intern/GHOST_C-api.o blender/intern/ghost/intern/GHOST_CallbackEventConsumer.o blender/intern/ghost/intern/GHOST_Context.o blender/intern/ghost/intern/GHOST_ContextNone.o blender/intern/ghost/intern/GHOST_DisplayManager.o blender/intern/ghost/intern/GHOST_EventManager.o blender/intern/ghost/intern/GHOST_ISystem.o blender/intern/ghost/intern/GHOST_ISystemPaths.o blender/intern/ghost/intern/GHOST_ModifierKeys.o blender/intern/ghost/intern/GHOST_Path-api.o blender/intern/ghost/intern/GHOST_Rect.o blender/intern/ghost/intern/GHOST_System.o blender/intern/ghost/intern/GHOST_TimerManager.o blender/intern/ghost/intern/GHOST_Window.o blender/intern/ghost/intern/GHOST_WindowManager.o blender/intern/ghost/intern/SPEC_SystemPathsSelect.o blender/intern/string/intern/STR_String.o blender/intern/memutil/intern/MEM_CacheLimiterC-Api.o blender/intern/memutil/intern/MEM_RefCountedC-Api.o blender/intern/guardedalloc/intern/mallocn.o blender/intern/guardedalloc/intern/mallocn_guarded_impl.o blender/intern/guardedalloc/intern/mallocn_lockfree_impl.o blender/extern/colamd/Source/colamd.o blender/extern/colamd/Source/colamd_global.o blender/source/blender/makesdna/intern/dna_genfile.o blender_bin/source/blender/makesdna/intern/dna.o blender/source/blender/blenfont/intern/blf.o blender/source/blender/blenfont/intern/blf_dir.o blender/source/blender/blenfont/intern/blf_font.o blender/source/blender/blenfont/intern/blf_glyph.o blender/source/blender/blenfont/intern/blf_lang.o blender/source/blender/blenfont/intern/blf_translation.o blender/source/blender/blenfont/intern/blf_util.o blender/intern/mikktspace/mikktspace.o blender/intern/raskter/raskter.o blender/intern/opencolorio/ocio_capi.o blender/intern/opencolorio/fallback_impl.o blender/extern/rangetree/range_tree_c_api.o blender/extern/wcwidth/wcwidth.o blender/extern/libmv/intern/stub.o blender/intern/glew-mx/intern/glew-mx.o blender/extern/glew/src/glew.o spec_gl.o spec_glcorearb.o spec_glu.o spec_glx.o spec_jpeg.o spec_ft.o zlib/adler32.o zlib/compress.o zlib/crc32.o zlib/deflate.o zlib/gzclose.o zlib/gzlib.o zlib/gzread.o zlib/gzwrite.o zlib/infback.o zlib/inflate.o zlib/inftrees.o zlib/trees.o zlib/uncompr.o zlib/zutil.o zlib/inffast.o libpng/png.o libpng/pngset.o libpng/pngget.o libpng/pngrutil.o libpng/pngtrans.o libpng/pngwutil.o libpng/pngmem.o libpng/pngpread.o libpng/pngread.o libpng/pngerror.o libpng/pngwrite.o libpng/pngrtran.o libpng/pngwtran.o libpng/pngrio.o libpng/pngwio.o specrand/specrand.o spec_backtrace.o                      -o blender_r  
